# train_cmd.cpp File Reference

Handling of trains. More...

`#include "stdafx.h"`
`#include "gui.h"`
`#include "articulated_vehicles.h"`
`#include "command_func.h"`
`#include "pathfinder/npf/npf_func.h"`
`#include "pathfinder/yapf/yapf.hpp"`
`#include "news_func.h"`
`#include "company_func.h"`
`#include "vehicle_gui.h"`
`#include "newgrf_engine.h"`
`#include "newgrf_sound.h"`
`#include "newgrf_text.h"`
`#include "group.h"`
`#include "table/sprites.h"`
`#include "strings_func.h"`
`#include "functions.h"`
`#include "window_func.h"`
`#include "vehicle_func.h"`
`#include "sound_func.h"`
`#include "autoreplace_gui.h"`
`#include "ai/ai.hpp"`
`#include "newgrf_station.h"`
`#include "effectvehicle_func.h"`
`#include "effectvehicle_base.h"`
`#include "gamelog.h"`
`#include "network/network.h"`
`#include "spritecache.h"`
`#include "core/random_func.hpp"`
`#include "company_base.h"`
`#include "engine_base.h"`
`#include "engine_func.h"`
`#include "newgrf.h"`
`#include "table/strings.h"`
`#include "table/train_cmd.h"`

Go to the source code of this file.

## Data Structures
class | VehicleOrderSaver
| This class will save the current order of a vehicle and restore it on destruction. More...
struct | RailtypeSlowdownParams
struct | TrainCollideChecker
## Defines
#define | MKIT(a, b, c, d) ((a & 0xFF) << 24) | ((b & 0xFF) << 16) | ((c & 0xFF) << 8) | ((d & 0xFF) << 0)
## Typedefs
typedef SmallVector< Train *, 16 > | TrainList
| Helper type for lists/vectors of trains.
## Functions
static Track | ChooseTrainTrack (Train *v, TileIndex tile, DiagDirection enterdir, TrackBits tracks, bool force_res, bool *got_reservation, bool mark_stuck)
static bool | TrainCheckIfLineEnds (Train *v)
| Checks for line end.
static void | TrainController (Train *v, Vehicle *nomove)
static TileIndex | TrainApproachingCrossingTile (const Train *v)
| Determines whether train is approaching a rail-road crossing (thus making it barred).
static void | CheckIfTrainNeedsService (Train *v)
static void | CheckNextTrainTile (Train *v)
| Check if the train is on the last reserved tile and try to extend the path then.
static DiagDirection | TrainExitDir (Direction direction, TrackBits track)
| Determine the side in which the train will leave the tile.
byte | FreightWagonMult (CargoID cargo)
| Return the cargo weight multiplier to use for a rail vehicle.
static void | RailVehicleLengthChanged (const Train *u)
| Logs a bug in GRF and shows a warning message if this is for the first time this happened.
void | CheckTrainsLengths ()
| Checks if lengths of all rail vehicles are valid.
int | GetTrainStopLocation (StationID station_id, TileIndex tile, const Train *v, int *station_ahead, int *station_length)
| Get the stop location of (the center) of the front vehicle of a train at a platform of a station.
static SpriteID | GetDefaultTrainSprite (uint8 spritenum, Direction direction)
static SpriteID | GetRailIcon (EngineID engine, bool rear_head, int &y)
void | DrawTrainEngine (int left, int right, int preferred_x, int y, EngineID engine, PaletteID pal)
static CommandCost | CmdBuildRailWagon (EngineID engine, TileIndex tile, DoCommandFlag flags)
static void | NormalizeTrainVehInDepot (const Train *u)
| Move all free vehicles in the depot to the train.
static void | AddRearEngineToMultiheadedTrain (Train *v)
CommandCost | CmdBuildRailVehicle (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Build a railroad vehicle.
static Train * | FindGoodVehiclePos (const Train *src)
static void | MakeTrainBackup (TrainList &list, Train *t)
| Make a backup of a train into a train list.
static void | RestoreTrainBackup (TrainList &list)
| Restore the train from the backup list.
static void | RemoveFromConsist (Train *part, bool chain=false)
| Remove the given wagon from it's consist.
static void | InsertInConsist (Train *dst, Train *chain)
| Inserts a chain into the train at dst.
static void | NormaliseDualHeads (Train *t)
| Normalise the dual heads in the train, i.e.
static void | NormaliseSubtypes (Train *chain)
| Normalise the sub types of the parts in this chain.
static CommandCost | CheckNewTrain (Train *original_dst, Train *dst, Train *original_src, Train *src)
| Check/validate whether we may actually build a new train.
static CommandCost | CheckTrainAttachment (Train *t)
| Check whether the train parts can be attached.
static CommandCost | ValidateTrains (Train *original_dst, Train *dst, Train *original_src, Train *src)
| Validate whether we are going to create valid trains.
static void | ArrangeTrains (Train **dst_head, Train *dst, Train **src_head, Train *src, bool move_chain)
| Arrange the trains in the wanted way.
static void | NormaliseTrainHead (Train *head)
| Normalise the head of the train again, i.e.
CommandCost | CmdMoveRailVehicle (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Move a rail vehicle around inside the depot.
CommandCost | CmdSellRailWagon (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Sell a (single) train wagon/engine.
static void | SetLastSpeed (Train *v, int spd)
static void | MarkTrainAsStuck (Train *v)
| Mark a train as stuck and stop it if it isn't stopped right now.
static void | SwapTrainFlags (uint16 *swap_flag1, uint16 *swap_flag2)
static void | ReverseTrainSwapVeh (Train *v, int l, int r)
static Vehicle * | TrainOnTileEnum (Vehicle *v, void *)
| Check if the vehicle is a train.
static Vehicle * | TrainApproachingCrossingEnum (Vehicle *v, void *data)
| Checks if a train is approaching a rail-road crossing.
static bool | TrainApproachingCrossing (TileIndex tile)
| Finds a vehicle approaching rail-road crossing.
void | UpdateLevelCrossing (TileIndex tile, bool sound)
| Sets correct crossing state.
static void | MaybeBarCrossingWithSound (TileIndex tile)
| Bars crossing and plays ding-ding sound if not barred already.
static void | AdvanceWagonsBeforeSwap (Train *v)
| Advances wagons for train reversing, needed for variable length wagons.
static void | AdvanceWagonsAfterSwap (Train *v)
| Advances wagons for train reversing, needed for variable length wagons.
static void | ReverseTrainDirection (Train *v)
CommandCost | CmdReverseTrainDirection (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Reverse train.
CommandCost | CmdForceTrainProceed (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Force a train through a red signal.
CommandCost | CmdRefitRailVehicle (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Refits a train to the specified cargo type.
static FindDepotData | FindClosestTrainDepot (Train *v, int max_distance)
| returns the tile of a depot to goto to.
CommandCost | CmdSendTrainToDepot (TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
| Send a train to a depot.
static void | HandleLocomotiveSmokeCloud (const Train *v)
static bool | CheckTrainStayInDepot (Train *v)
static void | ClearPathReservation (const Train *v, TileIndex tile, Trackdir track_dir)
| Clear the reservation of a tile that was just left by a wagon on track_dir.
void | FreeTrainTrackReservation (const Train *v, TileIndex origin, Trackdir orig_td)
| Free the reserved path in front of a vehicle.
static Track | DoTrainPathfind (const Train *v, TileIndex tile, DiagDirection enterdir, TrackBits tracks, bool *path_not_found, bool do_track_reservation, PBSTileInfo *dest)
| Perform pathfinding for a train.
static PBSTileInfo | ExtendTrainReservation (const Train *v, TrackBits *new_tracks, DiagDirection *enterdir)
| Extend a train path as far as possible.
static bool | TryReserveSafeTrack (const Train *v, TileIndex tile, Trackdir td, bool override_tailtype)
| Try to reserve any path to a safe tile, ignoring the vehicle's destination.
bool | TryPathReserve (Train *v, bool mark_as_stuck, bool first_tile_okay)
| Try to reserve a path to a safe position.
static bool | CheckReverseTrain (const Train *v)
static void | TrainEnterStation (Train *v, StationID station)
static byte | AfterSetTrainPos (Train *v, bool new_tile)
static bool | CheckCompatibleRail (const Train *v, TileIndex tile)
static void | AffectSpeedByZChange (Train *v, byte old_z)
| Modify the speed of the vehicle due to a change in altitude.
static bool | TrainMovedChangeSignals (TileIndex tile, DiagDirection dir)
static uint | TrainCrashed (Train *v)
| Marks train as crashed and creates an AI event.
static Vehicle * | FindTrainCollideEnum (Vehicle *v, void *data)
static bool | CheckTrainCollision (Train *v)
| Checks whether the specified train has a collision with another vehicle.
static Vehicle * | CheckTrainAtSignal (Vehicle *v, void *data)
static Vehicle * | CollectTrackbitsFromCrashedVehiclesEnum (Vehicle *v, void *data)
| Collect trackbits of all crashed train vehicles on a tile.
static void | DeleteLastWagon (Train *v)
| Deletes/Clears the last wagon of a crashed train.
static void | ChangeTrainDirRandomly (Train *v)
static bool | HandleCrashedTrain (Train *v)
static void | HandleBrokenTrain (Train *v)
static bool | TrainApproachingLineEnd (Train *v, bool signal)
| Train is approaching line end, slow down and possibly reverse.
static bool | TrainCanLeaveTile (const Train *v)
| Determines whether train would like to leave the tile.
static bool | TrainLocoHandler (Train *v, bool mode)
## Variables
static const byte | _vehicle_initial_x_fract [4] = {10, 8, 4, 8}
static const byte | _vehicle_initial_y_fract [4] = { 8, 4, 8, 10}
static const int8 | _vehicle_smoke_pos [8]
static const byte | _initial_tile_subcoord [6][4][3]
static const RailtypeSlowdownParams | _railtype_slowdown []
static const uint16 | _breakdown_speeds [16]
| Maximum speeds for train that is broken down or approaching line end.

## Detailed Description

Handling of trains.

Definition in file train_cmd.cpp.

## Function Documentation

static void AdvanceWagonsAfterSwap | ( | Train * | v | ) | `[static]`

Advances wagons for train reversing, needed for variable length wagons.

This one is called after the train is reversed.

Parameters:

  | v | First vehicle in chain

Definition at line 1801 of file train_cmd.cpp.

References TrainCache::cached_veh_length, GetRailDepotTrack(), SpecializedVehicle< T, Type >::Last(), SpecializedVehicle< T, Type >::Next(), SpecializedVehicle< T, Type >::Previous(), TicksToLeaveDepot(), Vehicle::tile, TRACK_BIT_DEPOT, TrackToTrackBits(), and Vehicle::vehstatus.

static void AdvanceWagonsBeforeSwap | ( | Train * | v | ) | `[static]`

Advances wagons for train reversing, needed for variable length wagons.

This one is called before the train is reversed.

Parameters:

  | v | First vehicle in chain

Definition at line 1773 of file train_cmd.cpp.

References TrainCache::cached_veh_length, SpecializedVehicle< T, Type >::Last(), SpecializedVehicle< T, Type >::Next(), and SpecializedVehicle< T, Type >::Previous().

static void ArrangeTrains | ( | Train ** | dst_head,
|  | Train * | dst,
|  | Train ** | src_head,
|  | Train * | src,
|  | bool | move_chain |
| ) |  |  | `[static]`

Arrange the trains in the wanted way.

Parameters:

  | dst_head | The destination chain of the to be moved vehicle.
  | dst | The destination for the to be moved vehicle.
  | src_head | The source chain of the to be moved vehicle.
  | src | The to be moved vehicle.
  | move_chain | Whether to move all vehicles after src or not.

Definition at line 1221 of file train_cmd.cpp.

References Train::GetNextUnit(), Train::GetNextVehicle(), InsertInConsist(), Train::IsMultiheaded(), NormaliseDualHeads(), and RemoveFromConsist().

Referenced by CmdMoveRailVehicle(), and CmdSellRailWagon().

static CommandCost CheckNewTrain | ( | Train * | original_dst,
|  | Train * | dst,
|  | Train * | original_src,
|  | Train * | src |
| ) |  |  | `[static]`

Check/validate whether we may actually build a new train.

Note:
  All vehicles are/were 'heads' of their chains.

Parameters:

  | original_dst | The original destination chain.
  | dst | The destination chain after constructing the train.
  | original_dst | The original source chain.
  | dst | The source chain after constructing the train.

Returns:
  possible error of this command.

Definition at line 1099 of file train_cmd.cpp.

References _settings_game, Train::IsEngine(), VehicleSettings::max_trains, return_cmd_error, VEH_TRAIN, and GameSettings::vehicle.

Referenced by ValidateTrains().

static void CheckNextTrainTile | ( | Train * | v | ) | `[static]`

Check if the train is on the last reserved tile and try to extend the path then.

Definition at line 2224 of file train_cmd.cpp.

References _settings_game, Vehicle::current_order, Vehicle::dest_tile, FindFirstTrackdir(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::Follow(), PathfinderSettings::forbid_90_deg, Order::GetDestination(), Vehicle::GetNumOrders(), GetSignalStateByTrackdir(), GetStationIndex(), Train::GetVehicleTrackdir(), HasPbsSignalOnTrackdir(), HasReservedTracks(), HasSignalOnTrackdir(), IsRailStationTile(), IsRailWaypointTile(), IsTileType(), Order::IsType(), KillFirstBit(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_exitdir, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_new_td_bits, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_new_tile, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_old_td, MP_RAILWAY, PathfinderSettings::path_backoff_interval, GameSettings::pf, ProcessOrders(), Order::ShouldStopAtStation(), SIGNAL_STATE_RED, Vehicle::tile, TRACK_BIT_DEPOT, TrackCrossesTracks(), TRACKDIR_BIT_NONE, TrackdirBitsToTrackBits(), and TrackdirToTrack().

static CommandCost CheckTrainAttachment | ( | Train * | t | ) | `[static]`

Check whether the train parts can be attached.

Parameters:

  | t | the train to check

Returns:
  possible error of this command.

Definition at line 1123 of file train_cmd.cpp.

References _settings_game, CALLBACK_FAILED, CBID_TRAIN_ALLOW_WAGON_ATTACH, error(), TrainCache::first_engine, GetEngineGRFID(), GetGRFStringID(), GetVehicleCallbackParent(), Vehicle::InvalidateNewGRFCache(), Train::IsArticulatedPart(), Train::IsEngine(), Train::IsRearDualheaded(), VehicleSettings::mammoth_trains, SpecializedVehicle< T, Type >::Next(), return_cmd_error, Vehicle::SetNext(), and GameSettings::vehicle.

Referenced by ValidateTrains().

static bool CheckTrainCollision | ( | Train * | v | ) | `[static]`

Checks whether the specified train has a collision with another vehicle.

If so, destroys this vehicle, and the other vehicle if its subtype has TS_Front. Reports the incident in a flashy news item, modifies station ratings and plays a sound.

Definition at line 3214 of file train_cmd.cpp.

References AddVehicleNewsItem(), FindVehicleOnPos(), FindVehicleOnPosXY(), GetOtherTunnelBridgeEnd(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, NS_ACCIDENT, TrainCollideChecker::num, SetDParam(), Vehicle::tile, TRACK_BIT_DEPOT, TRACK_BIT_WORMHOLE, and TrainCollideChecker::v.

void CheckTrainsLengths | ( |  | ) |

Checks if lengths of all rail vehicles are valid.

If not, shows an error message.

Definition at line 176 of file train_cmd.cpp.

References _networking, abs(), CMD_PAUSE, DoCommandP(), SpecializedVehicle< T, Type >::First(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_STRING_ID, max(), SpecializedVehicle< T, Type >::Next(), PM_PAUSED_ERROR, SetDParam(), ShowErrorMessage(), TicksToLeaveDepot(), TRACK_BIT_DEPOT, and Vehicle::vehstatus.

Referenced by InitializeWindowsAndCaches(), and ReloadNewGRFData().

static void ClearPathReservation | ( | const Train * | v,
|  | TileIndex | tile,
|  | Trackdir | track_dir |
| ) |  |  | `[static]`

Clear the reservation of a tile that was just left by a wagon on track_dir.

Definition at line 2339 of file train_cmd.cpp.

References _settings_client, GetOtherTunnelBridgeEnd(), GetTunnelBridgeDirection(), ClientSettings::gui, HasVehicleOnTunnelBridge(), IsCompatibleTrainStationTile(), IsRailStationTile(), IsTileType(), MarkTileDirtyByTile(), MP_TUNNELBRIDGE, ReverseDiagDir(), SetRailStationPlatformReservation(), SetTunnelBridgeReservation(), GUISettings::show_track_reservation, TileAddByDiagDir(), TrackdirToExitdir(), TrackdirToTrack(), and UnreserveRailTrack().

Referenced by Train::Crash(), and FreeTrainTrackReservation().

CommandCost CmdBuildRailVehicle | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Build a railroad vehicle.

Parameters:

  | tile | tile of the depot where rail-vehicle is built
  | flags | type of operation
  | p1 | engine type id
  | p2 | bit 1 prevents any free cars from being added to the train
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 817 of file train_cmd.cpp.

References _cur_year, _date, _settings_game, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_vehicle_pool >::CanAllocateItem(), RailVehicleInfo::capacity, Vehicle::cargo_cap, Vehicle::cargo_type, CheckConsistencyOfArticulatedVehicle(), CMD_ERROR, CmdBuildRailWagon(), Train::ConsistChanged(), CT_INVALID, DC_AUTOREPLACE, DC_EXEC, DC_QUERY_COST, DEFAULT_GROUP, DiagDirToDir(), ENGINE_EXCLUSIVE_PREVIEW, EXPENSES_NEW_VEHICLES, TrainCache::first_engine, GB(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), Engine::GetDefaultCargoType(), Engine::GetLifeLengthInDays(), GetRailDepotDirection(), GetRailType(), Vehicle::group_id, HasBit(), HasPowerOnRail(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, InvalidateAutoreplaceWindow(), InvalidateWindowClassesData(), InvalidateWindowData(), IsEngineBuildable(), IsRailDepotTile(), IsTileOwner(), Vehicle::max_speed, VehicleSettings::max_trains, NormalizeTrainVehInDepot(), RAILVEH_MULTIHEAD, RAILVEH_WAGON, return_cmd_error, SetBit(), Train::SetEngine(), Train::SetFrontEngine(), SetWindowDirty(), Vehicle::tile, TILE_SIZE, TileX(), TileY(), TRACK_BIT_DEPOT, UpdateTrainGroupID(), Vehicle::value, VEH_TRAIN, GameSettings::vehicle, Vehicle::vehicle_flags, VehicleMove(), VehicleRandomBits(), and Vehicle::vehstatus.

static CommandCost CmdBuildRailWagon | ( | EngineID | engine,
|  | TileIndex | tile,
|  | DoCommandFlag | flags |
| ) |  |  | `[static]`

< Same depot

< A free wagon chain

< Same type

< Don't connect to ourself

< Not crashed/flooded

Definition at line 670 of file train_cmd.cpp.

References _cur_year, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_vehicle_pool >::CanAllocateItem(), RailVehicleInfo::capacity, Vehicle::cargo_cap, Vehicle::cargo_type, CheckConsistencyOfArticulatedVehicle(), CMD_ERROR, CMD_MOVE_RAIL_VEHICLE, Train::ConsistChanged(), CT_INVALID, DC_EXEC, DC_QUERY_COST, DEFAULT_GROUP, DiagDirToDir(), DoCommand(), EXPENSES_NEW_VEHICLES, SpecializedVehicle< T, Type >::First(), TrainCache::first_engine, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), Engine::GetDefaultCargoType(), GetRailDepotDirection(), GetRailType(), Vehicle::group_id, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, InvalidateAutoreplaceWindow(), InvalidateWindowData(), IsCompatibleRail(), Train::IsFreeWagon(), SpecializedVehicle< T, Type >::Last(), return_cmd_error, Train::SetFreeWagon(), Train::SetWagon(), SetWindowDirty(), Vehicle::tile, TILE_SIZE, TileX(), TileY(), TRACK_BIT_DEPOT, UpdateTrainGroupID(), Vehicle::value, VehicleMove(), VehicleRandomBits(), and Vehicle::vehstatus.

Referenced by CmdBuildRailVehicle().

CommandCost CmdForceTrainProceed | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Force a train through a red signal.

Parameters:

  | tile | unused
  | flags | type of operation
  | p1 | train to ignore the red signal
  | p2 | unused
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 2011 of file train_cmd.cpp.

References CheckOwnership(), CMD_ERROR, DC_EXEC, SpecializedVehicle< Train, VEH_TRAIN >::GetIfValid(), HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Train::IsInDepot(), and SetWindowDirty().

CommandCost CmdMoveRailVehicle | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Move a rail vehicle around inside the depot.

Parameters:

  | tile | unused
  | flags | type of operation Note: DC_AUTOREPLACE is set when autoreplace tries to undo its modifications or moves vehicles to temporary locations inside the depot.
  | p1 | various bitstuffed elements p1 (bit 0 - 15) source vehicle index p1 (bit 16 - 31) what wagon to put the source wagon AFTER, XXX - INVALID_VEHICLE to make a new line
  | p2 | (bit 0) move all vehicles following the source vehicle
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 1294 of file train_cmd.cpp.

References ArrangeTrains(), CheckOwnership(), CMD_ERROR, DC_AUTOREPLACE, DC_EXEC, DEFAULT_GROUP, DeleteVehicleOrders(), DeleteWindowById(), CommandCost::Failed(), SpecializedVehicle< T, Type >::First(), GB(), Train::GetFirstEnginePart(), SpecializedVehicle< Train, VEH_TRAIN >::GetIfValid(), Train::GetLastEnginePart(), Vehicle::group_id, HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_VEHICLE, InvalidateWindowClassesData(), InvalidateWindowData(), Train::IsEngine(), Train::IsFrontEngine(), Train::IsRearDualheaded(), Train::IsStoppedInDepot(), MakeTrainBackup(), NormaliseSubtypes(), NormaliseTrainHead(), RemoveVehicleFromGroup(), RestoreTrainBackup(), return_cmd_error, SetTrainGroupID(), Vehicle::tile, ValidateTrains(), and Vehicle::vehstatus.

CommandCost CmdRefitRailVehicle | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Refits a train to the specified cargo type.

Parameters:

  | tile | unused
  | flags | type of operation
  | p1 | vehicle ID of the train to refit
  | p2 | various bitstuffed elements p2 = (bit 0-7) - the new cargo type to refit to p2 = (bit 8-15) - the new cargo subtype to refit to p2 = (bit 16) - refit only this vehicle
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 2040 of file train_cmd.cpp.

References CheckOwnership(), CMD_ERROR, Train::ConsistChanged(), DC_EXEC, SpecializedVehicle< T, Type >::First(), GB(), SpecializedVehicle< Train, VEH_TRAIN >::GetIfValid(), HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Vehicle::InvalidateNewGRFCacheOfChain(), InvalidateWindowClassesData(), Train::IsStoppedInDepot(), NUM_CARGO, RefitVehicle(), return_cmd_error, SetWindowDirty(), Vehicle::tile, and Vehicle::vehstatus.

CommandCost CmdReverseTrainDirection | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Reverse train.

Parameters:

  | tile | unused
  | flags | type of operation
  | p1 | train to reverse
  | p2 | if true, reverse a unit in a train (needs to be in a depot)
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 1944 of file train_cmd.cpp.

References _settings_game, CBM_VEHICLE_ARTIC_ENGINE, CheckOwnership(), CMD_ERROR, Vehicle::cur_speed, Vehicle::current_order, DC_EXEC, SpecializedVehicle< T, Type >::First(), SpecializedVehicle< Train, VEH_TRAIN >::GetIfValid(), GetStationIndex(), HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Train::IsMultiheaded(), Train::IsStoppedInDepot(), IsTileType(), Order::IsType(), MP_STATION, Vehicle::Next(), return_cmd_error, SetWindowDirty(), Vehicle::tile, ToggleBit(), VehicleSettings::train_acceleration_model, GameSettings::vehicle, and Vehicle::vehstatus.

CommandCost CmdSellRailWagon | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Sell a (single) train wagon/engine.

Parameters:

  | tile | unused
  | flags | type of operation
  | p1 | the wagon/engine index
  | p2 | the selling mode p2 = 0: only sell the single dragged wagon/engine (and any belonging rear-engines) p2 = 1: sell the vehicle and all vehicles following it in the chain if the wagon is dragged, don't delete the possibly belonging rear-engine to some front
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 1468 of file train_cmd.cpp.

References CommandCost::AddCost(), Vehicle::AddToShared(), ArrangeTrains(), CheckOwnership(), CMD_ERROR, Vehicle::CopyVehicleConfigAndStatistics(), DC_EXEC, DeleteVehicleOrders(), EXPENSES_NEW_VEHICLES, CommandCost::Failed(), SpecializedVehicle< T, Type >::First(), Train::GetFirstEnginePart(), SpecializedVehicle< Train, VEH_TRAIN >::GetIfValid(), Vehicle::group_id, HasBit(), InvalidateWindowClassesData(), InvalidateWindowData(), Train::IsEngine(), Train::IsFrontEngine(), Train::IsRearDualheaded(), Train::IsStoppedInDepot(), Vehicle::list, MakeTrainBackup(), SpecializedVehicle< T, Type >::Next(), NormaliseSubtypes(), NormaliseTrainHead(), RestoreTrainBackup(), return_cmd_error, ShowVehicleViewWindow(), Vehicle::tile, ValidateTrains(), Vehicle::value, and Vehicle::vehstatus.

CommandCost CmdSendTrainToDepot | ( | TileIndex | tile,
|  | DoCommandFlag | flags,
|  | uint32 | p1,
|  | uint32 | p2,
|  | const char * | text |
| ) |  |  |

Send a train to a depot.

Parameters:

  | tile | unused
  | flags | type of operation
  | p1 | train to send to the depot
  | p2 | various bitmasked elements p2 bit 0-3 - DEPOT_ flags (see vehicle.h) p2 bit 8-10 - VLW flag (for mass goto depot)
  | text | unused

Returns:
  the cost of this operation or an error

Definition at line 2112 of file train_cmd.cpp.

References CMD_ERROR, DEPOT_MASS_SEND, DEPOT_SERVICE, SpecializedVehicle< Train, VEH_TRAIN >::GetIfValid(), SendAllVehiclesToDepot(), Vehicle::SendToDepot(), and VEH_TRAIN.

static Vehicle* CollectTrackbitsFromCrashedVehiclesEnum | ( | Vehicle * | v,
|  | void * | data |
| ) |  |  | `[static]`

Collect trackbits of all crashed train vehicles on a tile.

Parameters:

  | v | Vehicle passed from Find/HasVehicleOnPos()
  | data | trackdirbits for the result

Returns:
  NULL to iterate over all vehicles on the tile.

Definition at line 3579 of file train_cmd.cpp.

References DiagDirToDiagTrackBits(), SpecializedVehicle< Train, VEH_TRAIN >::From(), GetTunnelBridgeDirection(), Vehicle::tile, TRACK_BIT_WORMHOLE, BaseVehicle::type, VEH_TRAIN, and Vehicle::vehstatus.

Referenced by DeleteLastWagon().

static void DeleteLastWagon | ( | Train * | v | ) | `[static]`

Deletes/Clears the last wagon of a crashed train.

It takes the engine of the train, then goes to the last wagon and deletes that. Each call to this function will remove the last wagon of a crashed train. If this wagon was on a crossing, or inside a tunnel/bridge, recalculate the signals as they might need updating

Parameters:

  | v | the Vehicle of which last wagon is to be removed

Definition at line 3602 of file train_cmd.cpp.

References CollectTrackbitsFromCrashedVehiclesEnum(), Train::ConsistChanged(), DiagDirToDiagTrackBits(), FindVehicleOnPos(), SpecializedVehicle< T, Type >::First(), GetTunnelBridgeDirection(), HasBit(), HasReservedTracks(), INVALID_DIAGDIR, IsRailDepotTile(), IsTileType(), MP_TUNNELBRIDGE, SpecializedVehicle< T, Type >::Next(), Vehicle::SetNext(), SetSignalsOnBothDir(), SetWindowDirty(), Vehicle::tile, TRACK_BEGIN, TRACK_BIT_DEPOT, TRACK_BIT_NONE, TRACK_BIT_WORMHOLE, TRACK_END, TRACK_X, TRACK_Y, TrackBitsToTrack(), TryReserveRailTrack(), UnreserveRailTrack(), UpdateLevelCrossing(), and UpdateSignalsOnSegment().

static Track DoTrainPathfind | ( | const Train * | v,
|  | TileIndex | tile,
|  | DiagDirection | enterdir,
|  | TrackBits | tracks,
|  | bool * | path_not_found,
|  | bool | do_track_reservation,
|  | PBSTileInfo * | dest |
| ) |  |  | `[static]`

Perform pathfinding for a train.

Parameters:

  | v | The train
  | tile | The tile the train is about to enter
  | enterdir | Diagonal direction the train is coming from
  | tracks | Usable tracks on the new tile
  | path_not_found | [out] Set to false if the pathfinder couldn't find a way to the destination
  | do_track_reservation | Path reservation is requested
  | dest | [out] State and destination of the requested path

Returns:
  The best track the train should follow

Definition at line 2442 of file train_cmd.cpp.

References _settings_game, NPFTrainChooseTrack(), PathfinderSettings::pathfinder_for_trains, GameSettings::pf, VPF_NPF, VPF_YAPF, and YapfTrainChooseTrack().

static PBSTileInfo ExtendTrainReservation | ( | const Train * | v,
|  | TrackBits * | new_tracks,
|  | DiagDirection * | enterdir |
| ) |  |  | `[static]`

Extend a train path as far as possible.

Stops on encountering a safe tile, another reservation or a track choice.

Returns:
  INVALID_TILE indicates that the reservation failed.

Definition at line 2457 of file train_cmd.cpp.

References _settings_game, FindFirstTrackdir(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::Follow(), FollowTrainReservation(), PathfinderSettings::forbid_90_deg, HasOnewaySignalBlockingTrackdir(), HasReservedTracks(), IsPlainRail(), IsSafeWaitingPosition(), IsTileType(), IsWaitingPositionFree(), KillFirstBit(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_exitdir, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_is_station, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_new_td_bits, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_new_tile, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_old_td, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_old_tile, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_tiles_skipped, MP_RAILWAY, GameSettings::pf, PBSTileInfo::tile, TileOffsByDiagDir(), PBSTileInfo::trackdir, TRACKDIR_BIT_NONE, TrackdirBitsToTrackBits(), TrackdirCrossesTrackdirs(), TrackdirReachesTrackdirs(), TrackdirToTrack(), TryReserveRailTrack(), and UnreserveRailTrack().

static FindDepotData FindClosestTrainDepot | ( | Train * | v,
|  | int | max_distance |
| ) |  |  | `[static]`

returns the tile of a depot to goto to.

The given vehicle must not be crashed!

Definition at line 2073 of file train_cmd.cpp.

References _settings_game, FollowTrainReservation(), IsRailDepotTile(), NPFTrainFindNearestDepot(), PathfinderSettings::pathfinder_for_trains, GameSettings::pf, PBSTileInfo::tile, Vehicle::tile, Vehicle::vehstatus, VPF_NPF, VPF_YAPF, and YapfTrainFindNearestDepot().

Referenced by Train::FindClosestDepot().

void FreeTrainTrackReservation | ( | const Train * | v,
|  | TileIndex | origin,
|  | Trackdir | orig_td |
| ) |  |  |

Free the reserved path in front of a vehicle.

Definition at line 2373 of file train_cmd.cpp.

References ClearPathReservation(), RailtypeInfo::compatible_railtypes, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::Follow(), GetRailTypeInfo(), GetReservedTrackbits(), GetSignalStateByTrackdir(), GetStationIndex(), Train::GetVehicleTrackdir(), HasPbsSignalOnTrackdir(), HasSignalOnTrackdir(), INVALID_TILE, INVALID_TRACKDIR, Train::IsFrontEngine(), IsOnewaySignal(), IsRailStationTile(), IsTileType(), IsValidTrackdir(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_is_bridge, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_is_station, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_is_tunnel, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_new_td_bits, CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::m_new_tile, MarkTileDirtyByTile(), MP_RAILWAY, MP_TUNNELBRIDGE, RemoveFirstTrackdir(), ReverseTrackdir(), SetSignalStateByTrackdir(), SIGNAL_STATE_RED, Vehicle::tile, TrackBitsToTrackdirBits(), TRACKDIR_BIT_NONE, TrackdirToTrack(), TracksOverlap(), TrackToTrackBits(), and UnreserveRailTrack().

Referenced by CmdBuildRailStation(), CmdBuildSingleSignal(), CmdConvertRail(), CmdRemoveSingleRail(), Train::Crash(), RemoveFromRailBaseStation(), and RemoveRailStation().

byte FreightWagonMult | ( | CargoID | cargo | ) |

Return the cargo weight multiplier to use for a rail vehicle.

Parameters:

  | cargo | Cargo type to get multiplier for

Returns:
  Cargo weight multiplier

Definition at line 85 of file train_cmd.cpp.

References _settings_game, VehicleSettings::freight_trains, CargoSpec::Get(), and GameSettings::vehicle.

Referenced by DrawTrainDetails(), Train::GetWeight(), TrainDetailsCapacityTab(), and TrainDetailsCargoTab().

int GetTrainStopLocation | ( | StationID | station_id,
|  | TileIndex | tile,
|  | const Train * | v,
|  | int * | station_ahead,
|  | int * | station_length |
| ) |  |  |

Get the stop location of (the center) of the front vehicle of a train at a platform of a station.

Parameters:

  | station_id | the ID of the station where we're stopping
  | tile | the tile where the vehicle currently is
  | v | the vehicle to get the stop location of
  | station_ahead | 'return' the amount of 1/16th tiles in front of the train
  | station_length | 'return' the station length in 1/16th tiles

Returns:
  the location, calculated from the begin of the station to stop at.

Definition at line 351 of file train_cmd.cpp.

References TrainCache::cached_total_length, TrainCache::cached_veh_length, Vehicle::current_order, DirToDiagDir(), SpecializedStation< Station, false >::Get(), Order::GetDestination(), Station::GetPlatformLength(), Order::GetStopLocation(), Order::IsType(), OSL_PLATFORM_FAR_END, OSL_PLATFORM_MIDDLE, OSL_PLATFORM_NEAR_END, and TILE_SIZE.

Referenced by Train::GetCurrentMaxSpeed().

static void InsertInConsist | ( | Train * | dst,
|  | Train * | chain |
| ) |  |  | `[static]`

Inserts a chain into the train at dst.

Parameters:

  | dst | the place where to append after.
  | chain | the chain to actually add.

Definition at line 1031 of file train_cmd.cpp.

References Train::IsArticulatedPart(), SpecializedVehicle< T, Type >::Last(), SpecializedVehicle< T, Type >::Next(), and Vehicle::SetNext().

Referenced by ArrangeTrains(), and NormaliseDualHeads().

static void MakeTrainBackup | ( | TrainList & | list,
|  | Train * | t |
| ) |  |  | `[static]`

Make a backup of a train into a train list.

Parameters:

  | list | to make the backup in
  | t | the train to make the backup of

Definition at line 981 of file train_cmd.cpp.

References SmallVector< T, S >::Append(), and SpecializedVehicle< T, Type >::Next().

Referenced by CmdMoveRailVehicle(), and CmdSellRailWagon().

static void MarkTrainAsStuck | ( | Train * | v | ) | `[static]`

Mark a train as stuck and stop it if it isn't stopped right now.

Definition at line 1586 of file train_cmd.cpp.

References Vehicle::cur_speed, HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, SetBit(), SetWindowWidgetDirty(), Vehicle::subspeed, and Train::wait_counter.

Referenced by TryPathReserve().

static void MaybeBarCrossingWithSound | ( | TileIndex | tile | ) | `[inline, static]`

Bars crossing and plays ding-ding sound if not barred already.

Parameters:

  | tile | tile with crossing

Precondition:
  tile is a rail-road crossing

Definition at line 1758 of file train_cmd.cpp.

References MarkTileDirtyByTile().

Referenced by TrainCheckIfLineEnds().

static void NormaliseDualHeads | ( | Train * | t | ) | `[static]`

Normalise the dual heads in the train, i.e.

if one is missing move that one to this train.

Parameters:

  | t | the train to normalise.

Definition at line 1045 of file train_cmd.cpp.

References Train::GetNextVehicle(), InsertInConsist(), Train::IsEngine(), Train::IsMultiheaded(), SpecializedVehicle< T, Type >::Next(), and RemoveFromConsist().

Referenced by ArrangeTrains().

static void NormaliseSubtypes | ( | Train * | chain | ) | `[static]`

Normalise the sub types of the parts in this chain.

Parameters:

  | chain | the chain to normalise.

Definition at line 1067 of file train_cmd.cpp.

References Train::ClearFreeWagon(), Train::ClearFrontEngine(), Train::IsEngine(), Train::IsWagon(), SpecializedVehicle< T, Type >::Next(), SpecializedVehicle< T, Type >::Previous(), Train::SetFreeWagon(), and Train::SetFrontEngine().

Referenced by CmdMoveRailVehicle(), and CmdSellRailWagon().

static void NormaliseTrainHead | ( | Train * | head | ) | `[static]`

Normalise the head of the train again, i.e.

that is tell the world that we have changed and update all kinds of variables.

Parameters:

  | head | the train to update.

Definition at line 1262 of file train_cmd.cpp.

References Train::ConsistChanged(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Train::IsFrontEngine(), SetWindowDirty(), SetWindowWidgetDirty(), UpdateTrainGroupID(), and VEH_TRAIN.

Referenced by CmdMoveRailVehicle(), and CmdSellRailWagon().

static void RailVehicleLengthChanged | ( | const Train * | u | ) | `[static]`

Logs a bug in GRF and shows a warning message if this is for the first time this happened.

Parameters:

  | u | first vehicle of chain

Definition at line 164 of file train_cmd.cpp.

References GamelogGRFBugReverse(), GBUG_VEH_LENGTH, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), GRFConfig::grf_bugs, HasBit(), Engine::internal_id, and ShowNewGrfVehicleError().

Referenced by Train::ConsistChanged().

static void RemoveFromConsist | ( | Train * | part,
|  | bool | chain = `false` |
| ) |  |  | `[static]`

Remove the given wagon from it's consist.

Parameters:

  | part | the part of the train to remove.
  | chain | whether to remove the whole chain.

Definition at line 1014 of file train_cmd.cpp.

References Train::GetLastEnginePart(), SpecializedVehicle< T, Type >::Last(), SpecializedVehicle< T, Type >::Next(), SpecializedVehicle< T, Type >::Previous(), and Vehicle::SetNext().

Referenced by ArrangeTrains(), and NormaliseDualHeads().

static void RestoreTrainBackup | ( | TrainList & | list | ) | `[static]`

Restore the train from the backup list.

Parameters:

  | list | the train to restore.

Definition at line 990 of file train_cmd.cpp.

References SmallVector< T, S >::Begin(), SmallVector< T, S >::End(), SmallVector< T, S >::Length(), SpecializedVehicle< T, Type >::Previous(), and Vehicle::SetNext().

Referenced by CmdMoveRailVehicle(), and CmdSellRailWagon().

static bool TrainApproachingCrossing | ( | TileIndex | tile | ) | `[static]`

Finds a vehicle approaching rail-road crossing.

Parameters:

  | tile | tile to test

Returns:
  true if a vehicle is approaching the crossing

Precondition:
  tile is a rail-road crossing

Definition at line 1714 of file train_cmd.cpp.

References AxisToDiagDir(), HasVehicleOnPos(), ReverseDiagDir(), TileOffsByDiagDir(), and TrainApproachingCrossingEnum().

Referenced by UpdateLevelCrossing().

static Vehicle* TrainApproachingCrossingEnum | ( | Vehicle * | v,
|  | void * | data |
| ) |  |  | `[static]`

Checks if a train is approaching a rail-road crossing.

Parameters:

  | v | vehicle on tile
  | data | tile with crossing we are testing

Returns:
  v if it is approaching a crossing, NULL otherwise

Definition at line 1693 of file train_cmd.cpp.

References SpecializedVehicle< Train, VEH_TRAIN >::From(), Train::IsFrontEngine(), TrainApproachingCrossingTile(), BaseVehicle::type, VEH_TRAIN, and Vehicle::vehstatus.

Referenced by TrainApproachingCrossing().

static TileIndex TrainApproachingCrossingTile | ( | const Train * | v | ) | `[static]`

Determines whether train is approaching a rail-road crossing (thus making it barred).

Parameters:

  | v | front engine of train

Returns:
  TileIndex of crossing the train is approaching, else INVALID_TILE

Precondition:
  v in non-crashed front engine

Definition at line 3839 of file train_cmd.cpp.

References DiagDirToAxis(), INVALID_TILE, Train::IsFrontEngine(), Vehicle::tile, TileOffsByDiagDir(), TrainCanLeaveTile(), TrainExitDir(), and Vehicle::vehstatus.

Referenced by Train::Crash(), and TrainApproachingCrossingEnum().

static bool TrainApproachingLineEnd | ( | Train * | v,
|  | bool | signal |
| ) |  |  | `[static]`

Train is approaching line end, slow down and possibly reverse.

Parameters:

  | v | front train engine
  | signal | not line end, just a red signal

Returns:
  true iff we did NOT have to reverse

Definition at line 3768 of file train_cmd.cpp.

References TrainCache::cached_veh_length, Vehicle::cur_speed, DIR_E, DIR_N, DIR_NE, DIR_NW, DIR_S, DIR_SE, DIR_W, TILE_SIZE, and Vehicle::vehstatus.

Referenced by TrainCheckIfLineEnds().

static bool TrainCanLeaveTile | ( | const Train * | v | ) | `[static]`

Determines whether train would like to leave the tile.

Parameters:

  | v | train to test

Returns:
  true iff vehicle is NOT entering or inside a depot or tunnel/bridge

Definition at line 3809 of file train_cmd.cpp.

References DiagDirToDir(), GetRailDepotDirection(), GetTunnelBridgeDirection(), IsRailDepotTile(), IsTileType(), MP_TUNNELBRIDGE, ReverseDiagDir(), Vehicle::tile, TRACK_BIT_DEPOT, and TRACK_BIT_WORMHOLE.

Referenced by TrainApproachingCrossingTile(), and TrainCheckIfLineEnds().

static bool TrainCheckIfLineEnds | ( | Train * | v | ) | `[static]`

Checks for line end.

Also, bars crossing at next tile if needed

Parameters:

  | v | vehicle we are checking

Returns:
  true iff we did NOT have to reverse

Definition at line 3865 of file train_cmd.cpp.

References _settings_game, Vehicle::cur_speed, DiagdirReachesTrackdirs(), FindFirstTrack(), PathfinderSettings::forbid_90_deg, GB(), GetTileTrackStatus(), MaybeBarCrossingWithSound(), GameSettings::pf, ReverseDiagDir(), Vehicle::tile, TileOffsByDiagDir(), TRACK_BIT_NONE, TrackCrossesTracks(), TrackdirBitsToTrackBits(), TrackStatusToRedSignals(), TrackStatusToTrackdirBits(), TrainApproachingLineEnd(), TrainCanLeaveTile(), TrainExitDir(), TRANSPORT_RAIL, and Vehicle::vehstatus.

static uint TrainCrashed | ( | Train * | v | ) | `[static]`

Marks train as crashed and creates an AI event.

Doesn't do anything if the train is crashed already.

Parameters:

  | v | first vehicle of chain

Returns:
  number of victims (including 2 drivers; zero if train was already crashed)

Definition at line 3147 of file train_cmd.cpp.

References Train::Crash(), AIEventVehicleCrashed::CRASH_TRAIN, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, AI::NewEvent(), Train::ReserveTrackUnderConsist(), Vehicle::tile, and Vehicle::vehstatus.

static DiagDirection TrainExitDir | ( | Direction | direction,
|  | TrackBits | track |
| ) |  |  | `[inline, static]`

Determine the side in which the train will leave the tile.

Parameters:

  | direction | vehicle direction
  | track | vehicle track bits

Returns:
  side of tile the train will leave

Definition at line 66 of file train_cmd.cpp.

References ChangeDiagDir(), DIAGDIR_END, DIAGDIRDIFF_90LEFT, DirToDiagDir(), HasBit(), TRACK_BIT_LEFT, TRACK_BIT_LOWER, TRACK_BIT_RIGHT, and TRACK_BIT_UPPER.

Referenced by TrainApproachingCrossingTile(), and TrainCheckIfLineEnds().

static Vehicle* TrainOnTileEnum | ( | Vehicle * | v,
|  | void * |  |
| ) |  |  | `[static]`

Check if the vehicle is a train.

Parameters:

  | v | vehicle on tile

Returns:
  v if it is a train, NULL otherwise

Definition at line 1681 of file train_cmd.cpp.

References BaseVehicle::type, and VEH_TRAIN.

Referenced by UpdateLevelCrossing().

bool TryPathReserve | ( | Train * | v,
|  | bool | mark_as_stuck,
|  | bool | first_tile_okay |
| ) |  |  |

Try to reserve a path to a safe position.

Parameters:

  | v | The vehicle
  | mark_as_stuck | Should the train be marked as stuck on a failed reservation?
  | first_tile_okay | True if no path should be reserved if the current tile is a safe position.

Returns:
  True if a path could be reserved.

Definition at line 2818 of file train_cmd.cpp.

References _settings_client, _settings_game, ClrBit(), DiagdirReachesTrackdirs(), DiagdirReachesTracks(), FollowTrainReservation(), PathfinderSettings::forbid_90_deg, GetRailDepotDirection(), GetTileTrackStatus(), ClientSettings::gui, HasBit(), HasDepotReservation(), HasReservedTracks(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Train::IsFrontEngine(), MarkTileDirtyByTile(), MarkTrainAsStuck(), PBSTileInfo::okay, GameSettings::pf, SetDepotReservation(), SetWindowWidgetDirty(), GUISettings::show_track_reservation, PBSTileInfo::tile, Vehicle::tile, TileAddByDiagDir(), TRACK_BIT_DEPOT, TrackCrossesTracks(), PBSTileInfo::trackdir, TrackdirBitsToTrackBits(), TrackdirToExitdir(), TrackdirToTrack(), TrackStatusToTrackdirBits(), TRANSPORT_RAIL, and Train::wait_counter.

Referenced by CmdBuildRailStation(), CmdBuildSingleSignal(), CmdConvertRail(), CmdRemoveSingleRail(), CmdRemoveSingleSignal(), RemoveFromRailBaseStation(), and RemoveRailStation().

static bool TryReserveSafeTrack | ( | const Train * | v,
|  | TileIndex | tile,
|  | Trackdir | td,
|  | bool | override_tailtype |
| ) |  |  | `[static]`

Try to reserve any path to a safe tile, ignoring the vehicle's destination.

Safe tiles are tiles in front of a signal, depots and station tiles at end of line.

Parameters:

  | v | The vehicle.
  | tile | The tile the search should start from.
  | td | The trackdir the search should start from.
  | override_railtype | Whether all physically compatible railtypes should be followed.

Returns:
  True if a path to a safe stopping tile could be reserved.

Definition at line 2549 of file train_cmd.cpp.

References _settings_game, NPFTrainFindNearestSafeTile(), PathfinderSettings::pathfinder_for_trains, GameSettings::pf, VPF_NPF, VPF_YAPF, and YapfTrainFindNearestSafeTile().

void UpdateLevelCrossing | ( | TileIndex | tile,
|  | bool | sound |
| ) |  |  |

Sets correct crossing state.

Parameters:

  | tile | tile to update
  | sound | should we play sound?

Precondition:
  tile is a rail-road crossing

Definition at line 1736 of file train_cmd.cpp.

References HasCrossingReservation(), HasVehicleOnPos(), MarkTileDirtyByTile(), TrainApproachingCrossing(), and TrainOnTileEnum().

Referenced by CmdBuildRoad(), CmdBuildSingleRail(), Train::Crash(), DeleteLastWagon(), and UnreserveRailTrack().

static CommandCost ValidateTrains | ( | Train * | original_dst,
|  | Train * | dst,
|  | Train * | original_src,
|  | Train * | src |
| ) |  |  | `[static]`

Validate whether we are going to create valid trains.

Note:
  All vehicles are/were 'heads' of their chains.

Parameters:

  | original_dst | The original destination chain.
  | dst | The destination chain after constructing the train.
  | original_dst | The original source chain.
  | dst | The source chain after constructing the train.

Returns:
  possible error of this command.

Definition at line 1201 of file train_cmd.cpp.

References CheckNewTrain(), CheckTrainAttachment(), and CommandCost::Failed().

Referenced by CmdMoveRailVehicle(), and CmdSellRailWagon().

## Variable Documentation

const uint16 _breakdown_speeds[16]`[static]`

Initial value:

     {
      225, 210, 195, 180, 165, 150, 135, 120, 105, 90, 75, 60, 45, 30, 15, 15
    }

Maximum speeds for train that is broken down or approaching line end.

Definition at line 3756 of file train_cmd.cpp.

const byte _initial_tile_subcoord[6][4][3]`[static]`

Initial value:

     {
    {{ 15, 8, 1 }, { 0, 0, 0 }, { 0, 8, 5 }, { 0,  0, 0 }},
    {{  0, 0, 0 }, { 8, 0, 3 }, { 0, 0, 0 }, { 8, 15, 7 }},
    {{  0, 0, 0 }, { 7, 0, 2 }, { 0, 7, 6 }, { 0,  0, 0 }},
    {{ 15, 8, 2 }, { 0, 0, 0 }, { 0, 0, 0 }, { 8, 15, 6 }},
    {{ 15, 7, 0 }, { 8, 0, 4 }, { 0, 0, 0 }, { 0,  0, 0 }},
    {{  0, 0, 0 }, { 0, 0, 0 }, { 0, 8, 4 }, { 7, 15, 0 }},
    }

Definition at line 2421 of file train_cmd.cpp.

const RailtypeSlowdownParams _railtype_slowdown[]`[static]`

Initial value:

     {

      {256 / 4, 256 / 2, 256 / 4, 2},
      {256 / 4, 256 / 2, 256 / 4, 2},
      {256 / 4, 256 / 2, 256 / 4, 2},
      {0,       256 / 2, 256 / 4, 2},
    }

Definition at line 3052 of file train_cmd.cpp.

const int8 _vehicle_smoke_pos[8]`[static]`

Initial value:

     {
      1, 1, 1, 0, -1, -1, -1, 0
    }

Definition at line 2126 of file train_cmd.cpp.